Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 45083)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 45084)
@@ -21,4 +21,5 @@
 #include <QFileInfo>
 #include <QVBoxLayout>
+#include <QGroupBox>
 
 /* Local includes: */
@@ -26,5 +27,4 @@
 #include "UIWizardImportApp.h"
 #include "VBoxGlobal.h"
-#include "QILabelSeparator.h"
 #include "VBoxFilePathSelectorWidget.h"
 #include "UIApplianceImportEditorWidget.h"
@@ -37,19 +37,31 @@
         pMainLayout->setContentsMargins(8, 6, 8, 6);
         pMainLayout->setSpacing(10);
-        m_pVMApplianceLabel = new QILabelSeparator(this);
-        m_pFileSelector = new VBoxEmptyFileSelector(this);
+        m_pApplianceCnt = new QGroupBox(this);
         {
-            m_pFileSelector->setHomeDir(vboxGlobal().documentsPath());
-            m_pFileSelector->setMode(VBoxFilePathSelectorWidget::Mode_File_Open);
+            QVBoxLayout *pApplianceCntLayout = new QVBoxLayout(m_pApplianceCnt);
+            {
+                m_pFileSelector = new VBoxEmptyFileSelector(m_pApplianceCnt);
+                {
+                    m_pFileSelector->setHomeDir(vboxGlobal().documentsPath());
+                    m_pFileSelector->setMode(VBoxFilePathSelectorWidget::Mode_File_Open);
+                }
+                pApplianceCntLayout->addWidget(m_pFileSelector);
+            }
         }
-        m_pApplianceWidget = new UIApplianceImportEditorWidget(this);
+        m_pSettingsCnt = new QGroupBox(this);
         {
-            m_pApplianceWidget->setMinimumHeight(300);
-            m_pApplianceWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::MinimumExpanding);
-            m_pApplianceWidget->setFile(strFileName);
+            QVBoxLayout *pSettingsCntLayout = new QVBoxLayout(m_pSettingsCnt);
+            {
+                m_pApplianceWidget = new UIApplianceImportEditorWidget(m_pSettingsCnt);
+                {
+                    m_pApplianceWidget->setMinimumHeight(300);
+                    m_pApplianceWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::MinimumExpanding);
+                    m_pApplianceWidget->setFile(strFileName);
+                }
+                pSettingsCntLayout->addWidget(m_pApplianceWidget);
+            }
         }
-        pMainLayout->addWidget(m_pVMApplianceLabel);
-        pMainLayout->addWidget(m_pFileSelector);
-        pMainLayout->addWidget(m_pApplianceWidget);
+        pMainLayout->addWidget(m_pApplianceCnt);
+        pMainLayout->addWidget(m_pSettingsCnt);
         m_pFileSelector->setPath(strFileName);
     }
@@ -80,8 +92,9 @@
 {
     /* Translate widgets: */
-    m_pVMApplianceLabel->setText(UIWizardImportApp::tr("Appliance to import"));
+    m_pApplianceCnt->setTitle(UIWizardImportApp::tr("Appliance to import"));
     m_pFileSelector->setChooseButtonText(UIWizardImportApp::tr("Open appliance..."));
     m_pFileSelector->setFileDialogTitle(UIWizardImportApp::tr("Please choose a virtual appliance file to import"));
     m_pFileSelector->setFileFilters(UIWizardImportApp::tr("Open Virtualization Format (%1)").arg("*.ova *.ovf"));
+    m_pSettingsCnt->setTitle(UIWizardImportApp::tr("Appliance settings"));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.h	(revision 45083)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.h	(revision 45084)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2009-2012 Oracle Corporation
+ * Copyright (C) 2009-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -25,5 +25,5 @@
 
 /* Forward declarations: */
-class QILabelSeparator;
+class QGroupBox;
 
 /* Expert page of the Import Appliance wizard: */
@@ -58,5 +58,6 @@
 
     /* Widgets: */
-    QILabelSeparator *m_pVMApplianceLabel;
+    QGroupBox *m_pApplianceCnt;
+    QGroupBox *m_pSettingsCnt;
 };
 