Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.cpp	(revision 45084)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.cpp	(revision 45085)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2008-2012 Oracle Corporation
+ * Copyright (C) 2008-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,4 +20,5 @@
 /* Local includes */
 #include "QIFileDialog.h"
+#include "QIToolButton.h"
 #include "QILabel.h"
 #include "QILineEdit.h"
@@ -35,5 +36,4 @@
 #include <QHBoxLayout>
 #include <QLineEdit>
-#include <QPushButton>
 #include <QTimer>
 
@@ -567,5 +567,5 @@
     , mMode (VBoxFilePathSelectorWidget::Mode_File_Open)
     , mLineEdit (NULL)
-    , m_fButtonTextSet(false)
+    , m_fButtonToolTipSet(false)
     , mHomeDir (QDir::current().absolutePath())
     , mIsModified (false)
@@ -574,9 +574,8 @@
     mMainLayout->setMargin (0);
 
-    mSelectButton = new QPushButton (this);
-    connect (mSelectButton, SIGNAL (clicked()),
-             this, SLOT (choose()));
-
-    mMainLayout->addWidget (mSelectButton);
+    mSelectButton = new QIToolButton(this);
+    mSelectButton->setIcon(UIIconPool::iconSet(":/select_file_16px.png", ":/select_file_dis_16px.png"));
+    connect(mSelectButton, SIGNAL(clicked()), this, SLOT(choose()));
+    mMainLayout->addWidget(mSelectButton);
 
     setEditable (false);
@@ -680,13 +679,13 @@
 }
 
-void VBoxEmptyFileSelector::setChooseButtonText(const QString &strText)
-{
-    mSelectButton->setText(strText);
-    m_fButtonTextSet = !strText.isEmpty();
-}
-
-QString VBoxEmptyFileSelector::chooseButtonText() const
-{
-    return mSelectButton->text();
+void VBoxEmptyFileSelector::setChooseButtonToolTip(const QString &strToolTip)
+{
+    m_fButtonToolTipSet = !strToolTip.isEmpty();
+    mSelectButton->setToolTip(strToolTip);
+}
+
+QString VBoxEmptyFileSelector::chooseButtonToolTip() const
+{
+    return mSelectButton->toolTip();
 }
 
@@ -723,6 +722,6 @@
 void VBoxEmptyFileSelector::retranslateUi()
 {
-    if (!m_fButtonTextSet)
-        mSelectButton->setText(tr("&Choose..."));
+    if (!m_fButtonToolTipSet)
+        mSelectButton->setToolTip(tr("Choose..."));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.h	(revision 45084)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxFilePathSelectorWidget.h	(revision 45085)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2008-2012 Oracle Corporation
+ * Copyright (C) 2008-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -33,5 +33,5 @@
 class QHBoxLayout;
 class QAction;
-class QPushButton;
+class QIToolButton;
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -162,6 +162,6 @@
     void resetModified () { mIsModified = false; }
 
-    void setChooseButtonText(const QString &aText);
-    QString chooseButtonText() const;
+    void setChooseButtonToolTip(const QString &strToolTip);
+    QString chooseButtonToolTip() const;
 
     void setFileDialogTitle (const QString& aTitle);
@@ -194,6 +194,6 @@
     VBoxFilePathSelectorWidget::Mode mMode;
     QILineEdit *mLineEdit;
-    QPushButton *mSelectButton;
-    bool m_fButtonTextSet;
+    QIToolButton *mSelectButton;
+    bool m_fButtonToolTipSet;
     QString mFileDialogTitle;
     QString mFileFilters;
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 45084)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 45085)
@@ -280,4 +280,5 @@
     m_pBucketLabel->setText(UIWizardExportApp::tr("&Bucket:"));
     m_pFileSelectorLabel->setText(UIWizardExportApp::tr("&File:"));
+    m_pFileSelector->setChooseButtonToolTip(tr("Choose a file to export virtual appliance..."));
     m_pFileSelector->setFileDialogTitle(UIWizardExportApp::tr("Please choose a file to export virtual appliance"));
     m_pFileSelector->setFileFilters(UIWizardExportApp::tr("Open Virtualization Format Archive (%1)").arg("*.ova") + ";;" +
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 45084)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 45085)
@@ -213,4 +213,5 @@
     m_pBucketLabel->setText(UIWizardExportApp::tr("&Bucket:"));
     m_pFileSelectorLabel->setText(UIWizardExportApp::tr("&File:"));
+    m_pFileSelector->setChooseButtonToolTip(tr("Choose a file to export virtual appliance..."));
     m_pFileSelector->setFileDialogTitle(UIWizardExportApp::tr("Please choose a file to export virtual appliance"));
     m_pFileSelector->setFileFilters(UIWizardExportApp::tr("Open Virtualization Format Archive (%1)").arg("*.ova") + ";;" +
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 45084)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 45085)
@@ -44,4 +44,6 @@
             m_pFileSelector->setHomeDir(vboxGlobal().documentsPath());
             m_pFileSelector->setMode(VBoxFilePathSelectorWidget::Mode_File_Open);
+            m_pFileSelector->setButtonPosition(VBoxEmptyFileSelector::RightPosition);
+            m_pFileSelector->setEditable(true);
         }
         pMainLayout->addWidget(m_pLabel);
@@ -63,5 +65,5 @@
                                             "saved in the Open Virtualization Format (OVF). "
                                             "To continue, select the file to import below.</p>"));
-    m_pFileSelector->setChooseButtonText(UIWizardImportApp::tr("Open appliance..."));
+    m_pFileSelector->setChooseButtonToolTip(UIWizardImportApp::tr("Choose a virtual appliance file to import..."));
     m_pFileSelector->setFileDialogTitle(UIWizardImportApp::tr("Please choose a virtual appliance file to import"));
     m_pFileSelector->setFileFilters(UIWizardImportApp::tr("Open Virtualization Format (%1)").arg("*.ova *.ovf"));
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 45084)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 45085)
@@ -45,4 +45,6 @@
                     m_pFileSelector->setHomeDir(vboxGlobal().documentsPath());
                     m_pFileSelector->setMode(VBoxFilePathSelectorWidget::Mode_File_Open);
+                    m_pFileSelector->setButtonPosition(VBoxEmptyFileSelector::RightPosition);
+                    m_pFileSelector->setEditable(true);
                 }
                 pApplianceCntLayout->addWidget(m_pFileSelector);
@@ -93,5 +95,5 @@
     /* Translate widgets: */
     m_pApplianceCnt->setTitle(UIWizardImportApp::tr("Appliance to import"));
-    m_pFileSelector->setChooseButtonText(UIWizardImportApp::tr("Open appliance..."));
+    m_pFileSelector->setChooseButtonToolTip(UIWizardImportApp::tr("Choose a virtual appliance file to import..."));
     m_pFileSelector->setFileDialogTitle(UIWizardImportApp::tr("Please choose a virtual appliance file to import"));
     m_pFileSelector->setFileFilters(UIWizardImportApp::tr("Open Virtualization Format (%1)").arg("*.ova *.ovf"));