Index: trunk/include/VBox/com/AutoLock.h
===================================================================
--- trunk/include/VBox/com/AutoLock.h	(revision 45058)
+++ trunk/include/VBox/com/AutoLock.h	(revision 45125)
@@ -1,4 +1,3 @@
 /** @file
- *
  * Automatic locks, implementation
  */
@@ -634,5 +633,5 @@
 } /* namespace util */
 
-#endif // ____H_AUTOLOCK
+#endif // !____H_AUTOLOCK
 
 /* vi: set tabstop=4 shiftwidth=4 expandtab: */
Index: trunk/include/VBox/com/ErrorInfo.h
===================================================================
--- trunk/include/VBox/com/ErrorInfo.h	(revision 45058)
+++ trunk/include/VBox/com/ErrorInfo.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * ErrorInfo class declaration
+ * MS COM / XPCOM Abstraction Layer - ErrorInfo class declaration.
  */
 
Index: trunk/include/VBox/com/EventQueue.h
===================================================================
--- trunk/include/VBox/com/EventQueue.h	(revision 45058)
+++ trunk/include/VBox/com/EventQueue.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * Event and EventQueue class declaration
+ * MS COM / XPCOM Abstraction Layer - Event and EventQueue class declaration.
  */
 
@@ -139,2 +138,3 @@
 
 #endif
+
Index: trunk/include/VBox/com/MultiResult.h
===================================================================
--- trunk/include/VBox/com/MultiResult.h	(revision 45058)
+++ trunk/include/VBox/com/MultiResult.h	(revision 45125)
@@ -1,7 +1,5 @@
 /* $Id$ */
-
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * MultiResult class declarations
+ * MS COM / XPCOM Abstraction Layer - MultiResult class declarations.
  */
 
@@ -259,4 +257,4 @@
 } /* namespace com */
 
-#endif /* ___VBox_com_MultiResult_h */
-
+#endif /* !___VBox_com_MultiResult_h */
+
Index: trunk/include/VBox/com/VirtualBox.h
===================================================================
--- trunk/include/VBox/com/VirtualBox.h	(revision 45058)
+++ trunk/include/VBox/com/VirtualBox.h	(revision 45125)
@@ -1,17 +1,14 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * VirtualBox COM Library definitions.
+ * MS COM / XPCOM Abstraction Layer - VirtualBox COM Library definitions.
  *
- * Note: This is the main header file that COM/XPCOM clients
- * include; however, it is only a wrapper around another
- * platform-dependent include file that contains the real
- * COM/XPCOM interface declarations. That other include file
- * is generated automatically at build time from
- * /src/VBox/Main/idl/VirtualBox.xidl, which contains all
- * the VirtualBox interfaces; the include file is called
- * VirtualBox.h on Windows hosts and VirtualBox_XPCOM.h
- * on Linux hosts. The build process places it in
- * out/<platform>/bin/sdk/include, from where it gets
- * included by the rest of the VirtualBox code.
+ * @note This is the main header file that COM/XPCOM clients include; however,
+ *       it is only a wrapper around another platform-dependent include file
+ *       that contains the real COM/XPCOM interface declarations.  That other
+ *       include file is generated automatically at build time from
+ *       /src/VBox/Main/idl/VirtualBox.xidl, which contains all the VirtualBox
+ *       interfaces; the include file is called VirtualBox.h on Windows hosts
+ *       and VirtualBox_XPCOM.h on Linux hosts.  The build process places it in
+ *       out/<platform>/bin/sdk/include, from where it gets
+ *       included by the rest of the VirtualBox code.
  */
 
@@ -54,2 +51,3 @@
 
 #endif
+
Index: trunk/include/VBox/com/array.h
===================================================================
--- trunk/include/VBox/com/array.h	(revision 45058)
+++ trunk/include/VBox/com/array.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * Safe array helper class declaration
+ * MS COM / XPCOM Abstraction Layer - Safe array helper class declaration.
  */
 
@@ -1700,3 +1699,4 @@
 /** @} */
 
-#endif /* ___VBox_com_array_h */
+#endif /* !___VBox_com_array_h */
+
Index: trunk/include/VBox/com/assert.h
===================================================================
--- trunk/include/VBox/com/assert.h	(revision 45058)
+++ trunk/include/VBox/com/assert.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * Assertion macros for COM/XPCOM
+ * MS COM / XPCOM Abstraction Layer - Assertion macros for COM/XPCOM.
  */
 
@@ -107,2 +106,3 @@
 
 #endif // !___VBox_com_assert_h
+
Index: trunk/include/VBox/com/com.h
===================================================================
--- trunk/include/VBox/com/com.h	(revision 45058)
+++ trunk/include/VBox/com/com.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * COM initialization / shutdown
+ * MS COM / XPCOM Abstraction Layer - COM initialization / shutdown.
  */
 
Index: trunk/include/VBox/com/defs.h
===================================================================
--- trunk/include/VBox/com/defs.h	(revision 45058)
+++ trunk/include/VBox/com/defs.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * Common definitions
+ * MS COM / XPCOM Abstraction Layer - Common definitions.
  */
 
@@ -556,3 +555,4 @@
 } /* namespace com */
 
-#endif /* ___VBox_com_defs_h */
+#endif /* !___VBox_com_defs_h */
+
Index: trunk/include/VBox/com/errorprint.h
===================================================================
--- trunk/include/VBox/com/errorprint.h	(revision 45058)
+++ trunk/include/VBox/com/errorprint.h	(revision 45125)
@@ -1,6 +1,8 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
+ * MS COM / XPCOM Abstraction Layer - Error Reporting.
+ *
  * Error printing macros using shared functions defined in shared glue code.
- * Use these CHECK_* macros for efficient error checking around calling COM methods.
+ * Use these CHECK_* macros for efficient error checking around calling COM
+ * methods.
  */
 
@@ -260,2 +262,3 @@
 
 } /* namespace com */
+
Index: trunk/include/VBox/com/listeners.h
===================================================================
--- trunk/include/VBox/com/listeners.h	(revision 45058)
+++ trunk/include/VBox/com/listeners.h	(revision 45125)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * Listeners helpers.
+ * MS COM / XPCOM Abstraction Layer - Listeners helpers.
  */
 
@@ -170,2 +170,3 @@
 
 #endif
+
Index: trunk/include/VBox/com/ptr.h
===================================================================
--- trunk/include/VBox/com/ptr.h	(revision 45058)
+++ trunk/include/VBox/com/ptr.h	(revision 45125)
@@ -1,5 +1,4 @@
 /** @file
- * MS COM / XPCOM Abstraction Layer:
- * Smart COM pointer classes declaration
+ * MS COM / XPCOM Abstraction Layer - Smart COM pointer classes declaration.
  */
 
@@ -492,2 +491,3 @@
 };
 #endif
+