Index: trunk/doc/manual/en_US/user_AdvancedTopics.xml
===================================================================
--- trunk/doc/manual/en_US/user_AdvancedTopics.xml	(revision 45174)
+++ trunk/doc/manual/en_US/user_AdvancedTopics.xml	(revision 45175)
@@ -252,4 +252,8 @@
       guest logons on platforms which support this framework. Virtually all
       modern Linux/Unix distributions rely on PAM.</para>
+
+      <para>For automated logons on Ubuntu (or Ubuntu-derived) distributions
+      using LightDM as the display manager, please see
+      <xref linkend="autologon_unix_lightdm" />.</para>
 
       <para>The <computeroutput>pam_vbox.so</computeroutput> module itself
@@ -406,4 +410,122 @@
           <computeroutput>debug</computeroutput> option.</para>
         </note></para>
+
+      <sect3 id="autologon_unix_lightdm">
+        <title>VirtualBox Greeter for Ubuntu / LightDM</title>
+
+        <para>Starting with version 4.2.6, VirtualBox comes with an own greeter
+        module named vbox-greeter which can be used with LightDM 1.0.1 or later.
+        LightDM is the default display manager since Ubuntu 10.11 and therefore
+        also can be used for automated guest logons.</para>
+
+        <para>vbox-greeter does not need the pam_vbox module described above
+        in order to function -- it comes with its own authentication mechanism
+        provided by LightDM. However, to provide maximum of flexibility both
+        modules can be used together on the same guest.</para>
+
+        <para>As for the pam_vbox module, vbox-greeter is shipped as part of
+        the Guest Additions but it is not installed and/or activated on the
+        guest OS by default For installing vbox-greeter automatically upon
+        Guest Additions installation, use the 
+        <computeroutput>--with-autologon</computeroutput> switch when starting
+        the VBoxLinuxAdditions.run file:<screen>
+        # ./VBoxLinuxAdditions.run -- --with-autologon</screen></para>
+
+        <para>For manual or postponed installation, the
+        <computeroutput>vbox-greeter.desktop</computeroutput>
+        file has to be copied from
+        <computeroutput>/opt/VBoxGuestAdditions-&lt;version&gt;/shared/VBoxGuestAdditions/</computeroutput>
+        to the <computeroutput>xgreeters</computeroutput> directory, usually
+        <computeroutput>/usr/share/xgreeters/</computeroutput>.
+        Please refer to your guest OS documentation for the correct LightDM
+        greeter directory.</para>
+
+        <para>The vbox-greeter module itself already was installed by the
+        VirtualBox Guest Additions installer and resides in
+        <computeroutput>/usr/sbin/</computeroutput>. To enable vbox-greeter as
+        the standard greeter module, the file
+        <computeroutput>/etc/lightdm/lightdm.conf</computeroutput> needs to be
+        edited:</para>
+
+        <para><screen>
+        [SeatDefaults]
+        greeter-session=vbox-greeter</screen></para>
+
+        <note><para>The LightDM server needs to be fully restarted in order to
+        get vbox-greeter used as the default greeter. As root, do a
+        <computeroutput>service lightdm --full-restart</computeroutput> on
+        Ubuntu, or simply restart the guest.</para></note>
+
+        <note><para>vbox-greeter is independent of the graphical session chosen
+        by the user (like Gnome, KDE, Unity etc). However it requires FLTK 1.3
+        for representing its user interface.</para></note>
+
+        <para>In addition to the guest property values of the
+        pam_vbox module listed above, vbox-greeter has the following guest
+        properties for further customizing its user interface, residing all in
+        <computeroutput>/VirtualBox/GuestAdd/Greeter/</computeroutput>:</para>
+
+        <orderedlist>
+          <listitem>
+            <para><computeroutput>HideRestart</computeroutput>: Set to "1" if
+            vbox-greeter should hide the button to restart the guest. This
+            property must be set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>HideShutdown</computeroutput>: Set to "1" if
+            vbox-greeter should hide the button to shutdown the guest. This
+            property must be set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>BannerPath</computeroutput>: Path to a .PNG
+            file for using it as a banner on the top. The image size must be
+            460 x 90 pixels, any bit depth. This property must be
+            set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>UseTheming</computeroutput>: Set to "1" for
+            turning on the following theming options. This property must be
+            set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>Theme/BackgroundColor</computeroutput>:
+            Hexadecimal RRGGBB color for the background. This property must be
+            set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>Theme/LogonDialog/HeaderColor</computeroutput>:
+            Hexadecimal RRGGBB foreground color for the header text. This
+            property must be set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>Theme/LogonDialog/BackgroundColor</computeroutput>:
+            Hexadecimal RRGGBB color for the logon dialog background. This
+            property must be set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>Theme/LogonDialog/ButtonColor</computeroutput>:
+            Hexadecimal RRGGBB background color for the logon dialog button. This
+            property must be set read-only for the guest
+            (<computeroutput>RDONLYGUEST</computeroutput>).</para>
+          </listitem>
+        </orderedlist>
+
+        <note><para>The same restrictions for the guest properties above apply
+        as for the ones specified in the pam_vbox section.</para></note>
+      </sect3>
     </sect2>
   </sect1>