Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 45193)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 45196)
@@ -187,11 +187,11 @@
                                             ":/remove_shared_folder_disabled_16px.png"));
 
-    /* Prepare toolbar */
-    mTbFolders->setUsesTextLabel (false);
-    mTbFolders->setIconSize (QSize (16, 16));
-    mTbFolders->setOrientation (Qt::Vertical);
-    mTbFolders->addAction (mNewAction);
-    mTbFolders->addAction (mEdtAction);
-    mTbFolders->addAction (mDelAction);
+    /* Prepare tool-bar: */
+    m_pFoldersToolBar->setUsesTextLabel(false);
+    m_pFoldersToolBar->setIconSize(QSize(16, 16));
+    m_pFoldersToolBar->setOrientation(Qt::Vertical);
+    m_pFoldersToolBar->addAction(mNewAction);
+    m_pFoldersToolBar->addAction(mEdtAction);
+    m_pFoldersToolBar->addAction(mDelAction);
 
     /* Setup connections */
@@ -700,6 +700,6 @@
     /* Update widgets availability: */
     mNameSeparator->setEnabled(isMachineInValidMode());
-    mTwFolders->setEnabled(isMachineInValidMode());
-    mTbFolders->setEnabled(isMachineInValidMode());
+    m_pFoldersToolBar->setEnabled(isMachineInValidMode());
+    m_pFoldersToolBar->setEnabled(isMachineInValidMode());
 
     /* Update root items visibility: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.ui	(revision 45193)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.ui	(revision 45196)
@@ -38,57 +38,68 @@
    </item>
    <item>
-    <layout class="QHBoxLayout" name="mLtFolders">
-     <property name="margin">
-      <number>0</number>
-     </property>
-     <property name="spacing">
-      <number>3</number>
-     </property>
-     <item>
-      <widget class="QTreeWidget" name="mTwFolders">
-       <property name="minimumSize">
-        <size>
-         <width>0</width>
-         <height>200</height>
-        </size>
-       </property>
-       <property name="contextMenuPolicy">
-        <enum>Qt::CustomContextMenu</enum>
-       </property>
-       <property name="whatsThis">
-        <string>Lists all shared folders accessible to this machine. Use 'net use x: \\vboxsvr\share' to access a shared folder named &lt;i>share&lt;/i> from a DOS-like OS, or 'mount -t vboxsf share mount_point' to access it from a Linux OS. This feature requires Guest Additions.</string>
-       </property>
-       <property name="uniformRowHeights">
-        <bool>true</bool>
-       </property>
-       <property name="allColumnsShowFocus">
-        <bool>true</bool>
-       </property>
-       <column>
-        <property name="text">
-         <string>Name</string>
+    <widget class="QWidget" native="1" name="mTwFoldersContainer">
+     <layout class="QHBoxLayout" name="mLtFolders">
+      <property name="leftMargin">
+       <number>0</number>
+      </property>
+      <property name="topMargin">
+       <number>0</number>
+      </property>
+      <property name="rightMargin">
+       <number>0</number>
+      </property>
+      <property name="bottomMargin">
+       <number>0</number>
+      </property>
+      <property name="spacing">
+       <number>3</number>
+      </property>
+      <item>
+       <widget class="QTreeWidget" name="mTwFolders">
+        <property name="minimumSize">
+         <size>
+          <width>0</width>
+          <height>200</height>
+         </size>
         </property>
-       </column>
-       <column>
-        <property name="text">
-         <string>Path</string>
+        <property name="contextMenuPolicy">
+         <enum>Qt::CustomContextMenu</enum>
         </property>
-       </column>
-       <column>
-        <property name="text">
-         <string>Auto-Mount</string>
+        <property name="whatsThis">
+         <string>Lists all shared folders accessible to this machine. Use 'net use x: \\vboxsvr\share' to access a shared folder named &lt;i>share&lt;/i> from a DOS-like OS, or 'mount -t vboxsf share mount_point' to access it from a Linux OS. This feature requires Guest Additions.</string>
         </property>
-       </column>
-       <column>
-        <property name="text">
-         <string>Access</string>
+        <property name="uniformRowHeights">
+         <bool>true</bool>
         </property>
-       </column>
-      </widget>
-     </item>
-     <item>
-      <widget class="UIToolBar" native="1" name="mTbFolders"/>
-     </item>
-    </layout>
+        <property name="allColumnsShowFocus">
+         <bool>true</bool>
+        </property>
+        <column>
+         <property name="text">
+          <string>Name</string>
+         </property>
+        </column>
+        <column>
+         <property name="text">
+          <string>Path</string>
+         </property>
+        </column>
+        <column>
+         <property name="text">
+          <string>Auto-Mount</string>
+         </property>
+        </column>
+        <column>
+         <property name="text">
+          <string>Access</string>
+         </property>
+        </column>
+       </widget>
+      </item>
+      <item>
+       <widget class="UIToolBar" native="1" name="m_pFoldersToolBar"/>
+      </item>
+     </layout>
+    </widget>
    </item>
   </layout>
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.cpp	(revision 45193)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.cpp	(revision 45196)
@@ -176,25 +176,14 @@
                                             ":/usb_movedown_disabled_16px.png"));
 
-    /* Prepare toolbar */
-    m_pToolBar = new UIToolBar (mWtFilterHandler);
-    m_pToolBar->setUsesTextLabel (false);
-    m_pToolBar->setIconSize (QSize (16, 16));
-    m_pToolBar->setOrientation (Qt::Vertical);
-    m_pToolBar->addAction (mNewAction);
-    m_pToolBar->addAction (mAddAction);
-    m_pToolBar->addAction (mEdtAction);
-    m_pToolBar->addAction (mDelAction);
-    m_pToolBar->addAction (mMupAction);
-    m_pToolBar->addAction (mMdnAction);
-    m_pToolBar->setSizePolicy (QSizePolicy::Fixed, QSizePolicy::MinimumExpanding);
-    m_pToolBar->updateGeometry();
-#ifdef Q_WS_MAC
-    /* On the Mac this has to be slightly higher, than what sizeHint returned.
-     * No idea why. */
-    m_pToolBar->setMinimumHeight(m_pToolBar->sizeHint().height() + 4);
-#else
-    m_pToolBar->setMinimumHeight(m_pToolBar->sizeHint().height());
-#endif /* Q_WS_MAC */
-    mWtFilterHandler->layout()->addWidget (m_pToolBar);
+    /* Prepare tool-bar: */
+    m_pFiltersToolBar->setUsesTextLabel(false);
+    m_pFiltersToolBar->setIconSize(QSize(16, 16));
+    m_pFiltersToolBar->setOrientation(Qt::Vertical);
+    m_pFiltersToolBar->addAction(mNewAction);
+    m_pFiltersToolBar->addAction(mAddAction);
+    m_pFiltersToolBar->addAction(mEdtAction);
+    m_pFiltersToolBar->addAction(mDelAction);
+    m_pFiltersToolBar->addAction(mMupAction);
+    m_pFiltersToolBar->addAction(mMdnAction);
 
     /* Setup connections */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.ui	(revision 45193)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsUSB.ui	(revision 45196)
@@ -108,4 +108,10 @@
          <item>
           <widget class="QTreeWidget" name="mTwFilters" >
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="MinimumExpanding" vsizetype="MinimumExpanding">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
            <property name="contextMenuPolicy" >
             <enum>Qt::CustomContextMenu</enum>
@@ -124,4 +130,7 @@
           </widget>
          </item>
+         <item>
+          <widget class="UIToolBar" native="1" name="m_pFiltersToolBar"/>
+         </item>
         </layout>
        </widget>
@@ -138,4 +147,10 @@
    <header>QILabelSeparator.h</header>
   </customwidget>
+  <customwidget>
+   <class>UIToolBar</class>
+   <extends>QWidget</extends>
+   <header>UIToolBar.h</header>
+   <container>1</container>
+  </customwidget>
  </customwidgets>
  <resources/>