Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45273)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45274)
@@ -644,11 +644,13 @@
 void UIMessageCenter::cannotSetGroups(const CMachine &machine)
 {
+    /* Preserve error-info: */
     COMResult res(machine);
-    QString name = machine.GetName();
-    if (name.isEmpty())
-        name = QFileInfo(machine.GetSettingsFilePath()).baseName();
-
+    /* Compose machine name: */
+    QString strName = machine.GetName();
+    if (strName.isEmpty())
+        strName = QFileInfo(machine.GetSettingsFilePath()).baseName();
+    /* Show the message: */
     message(mainWindowShown(), MessageType_Error,
-            tr("Failed to set groups of the virtual machine <b>%1</b>.").arg(name),
+            tr("Failed to set groups of the virtual machine <b>%1</b>.").arg(strName),
             formatErrorInfo(res));
 }
@@ -837,32 +839,35 @@
 }
 
-void UIMessageCenter::cannotLoadMachineSettings(const CMachine &machine,
-                                                bool fStrict /* = true */,
-                                                QWidget *pParent /* = 0 */)
-{
-    /* If COM result code is E_NOTIMPL, it means the requested object or
-     * function is intentionally missing (as in the OSE version). Don't show
-     * the error message in this case. */
+void UIMessageCenter::cannotLoadMachineSettings(const CMachine &machine, bool fStrict /*= true*/, QWidget *pParent /*= 0*/)
+{
+    /* This function is NOT use currently.
+     * We are keeping it here just for convinience with Save analog. */
+
+    /* Preserve error-info.
+     * If COM result code is E_NOTIMPL, it means the requested
+     * object or function is intentionally missing (as in the OSE version).
+     * Don't show the error message in this case. */
     COMResult res(machine);
     if (!fStrict && res.rc() == E_NOTIMPL)
         return;
 
+    /* Show the message: */
     message(pParent ? pParent : mainWindowShown(), MessageType_Error,
-             tr("Failed to load the settings of the virtual machine "
-                 "<b>%1</b> from <b><nobr>%2</nobr></b>.")
-                .arg(machine.GetName(), machine.GetSettingsFilePath()),
-             formatErrorInfo(res));
-}
-
-void UIMessageCenter::cannotSaveMachineSettings(const CMachine &machine, QWidget *pParent /* = 0 */)
-{
-    /* preserve the current error info before calling the object again */
+            tr("Failed to load the settings of the virtual machine "
+               "<b>%1</b> from <b><nobr>%2</nobr></b>.")
+               .arg(machine.GetName(), machine.GetSettingsFilePath()),
+            formatErrorInfo(res));
+}
+
+void UIMessageCenter::cannotSaveMachineSettings(const CMachine &machine, QWidget *pParent /*= 0*/)
+{
+    /* Preserve error-info: */
     COMResult res(machine);
-
+    /* Show the message: */
     message(pParent ? pParent : mainWindowShown(), MessageType_Error,
-             tr("Failed to save the settings of the virtual machine "
-                 "<b>%1</b> to <b><nobr>%2</nobr></b>.")
-                 .arg(machine.GetName(), machine.GetSettingsFilePath()),
-             formatErrorInfo(res));
+            tr("Failed to save the settings of the virtual machine "
+               "<b>%1</b> to <b><nobr>%2</nobr></b>.")
+               .arg(machine.GetName(), machine.GetSettingsFilePath()),
+            formatErrorInfo(res));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 45273)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 45274)
@@ -1354,5 +1354,5 @@
         if (!machine.isOk())
         {
-            msgCenter().cannotSaveMachineSettings (machine);
+            msgCenter().cannotSaveMachineSettings(machine, this);
             success = false;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 45273)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 45274)
@@ -1508,5 +1508,5 @@
         machine.SaveSettings();
         if (!machine.isOk())
-            msgCenter().cannotSaveMachineSettings(machine);
+            msgCenter().cannotSaveMachineSettings(machine, activeMachineWindow());
     }
 }
@@ -1567,5 +1567,5 @@
             machine.SaveSettings();
             if (!machine.isOk())
-                msgCenter().cannotSaveMachineSettings(machine);
+                msgCenter().cannotSaveMachineSettings(machine, activeMachineWindow());
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 45273)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 45274)
@@ -862,5 +862,5 @@
     /* If machine is NOT ok => show the error message: */
     if (!m_machine.isOk())
-        msgCenter().cannotSaveMachineSettings(m_machine);
+        msgCenter().cannotSaveMachineSettings(m_machine, this);
 
     /* Mark page processed: */
@@ -1090,7 +1090,4 @@
         return false;
 
-    /* Show the machine error message for particular group if present.
-     * We don't use the generic cannotLoadMachineSettings()
-     * call here because we want this message to be suppressible. */
     switch (iPageId)
     {