Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45279)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45280)
@@ -478,38 +478,44 @@
 void UIMessageCenter::cannotDiscardSavedState(const CConsole &console)
 {
-    /* preserve the current error info before calling the object again */
+    /* Preserve error-info: */
     COMResult res(console);
-
+    /* Show the message: */
     message(mainWindowShown(), MessageType_Error,
-        tr("Failed to discard the saved state of the virtual machine <b>%1</b>.")
-            .arg(console.GetMachine().GetName()),
-        formatErrorInfo(res));
-}
-
-void UIMessageCenter::notifyAboutCollisionOnGroupRemovingCantBeResolved(const QString &strName, const QString &strGroupName)
-{
-    message(&vboxGlobal().selectorWnd(),
-            MessageType_Error,
+            tr("Failed to discard the saved state of the virtual machine <b>%1</b>.").arg(console.GetMachine().GetName()),
+            formatErrorInfo(res));
+}
+
+void UIMessageCenter::cannotSetGroups(const CMachine &machine)
+{
+    /* Preserve error-info: */
+    COMResult res(machine);
+    /* Compose machine name: */
+    QString strName = machine.GetName();
+    if (strName.isEmpty())
+        strName = QFileInfo(machine.GetSettingsFilePath()).baseName();
+    /* Show the message: */
+    message(mainWindowShown(), MessageType_Error,
+            tr("Failed to set groups of the virtual machine <b>%1</b>.").arg(strName),
+            formatErrorInfo(res));
+}
+
+void UIMessageCenter::cannotResolveCollisionAutomatically(const QString &strName, const QString &strGroupName)
+{
+    message(mainWindowShown(), MessageType_Error,
             tr("<p>You are trying to move machine <nobr><b>%1</b></nobr> "
                "to group <nobr><b>%2</b></nobr> which already have sub-group <nobr><b>%1</b></nobr>.</p>"
                "<p>Please resolve this name-conflict and try again.</p>")
-               .arg(strName, strGroupName),
-            0, /* auto-confirm id */
-            QIMessageBox::Ok | QIMessageBox::Default);
-}
-
-int UIMessageCenter::askAboutCollisionOnGroupRemoving(const QString &strName, const QString &strGroupName)
-{
-    return message(&vboxGlobal().selectorWnd(),
-                   MessageType_Question,
-                   tr("<p>You are trying to move group <nobr><b>%1</b></nobr> "
-                      "to group <nobr><b>%2</b></nobr> which already have another item with the same name.</p>"
-                      "<p>Would you like to automatically rename it?</p>")
-                      .arg(strName, strGroupName),
-                   0, /* auto-confirm id */
-                   QIMessageBox::Ok,
-                   QIMessageBox::Cancel | QIMessageBox::Escape | QIMessageBox::Default,
-                   0,
-                   tr("Rename"));
+               .arg(strName, strGroupName));
+}
+
+bool UIMessageCenter::confirmAutomaticCollisionResolve(const QString &strName, const QString &strGroupName)
+{
+    return messageOkCancel(mainWindowShown(), MessageType_Question,
+                           tr("<p>You are trying to move group <nobr><b>%1</b></nobr> "
+                              "to group <nobr><b>%2</b></nobr> which already have another item with the same name.</p>"
+                              "<p>Would you like to automatically rename it?</p>")
+                              .arg(strName, strGroupName),
+                           0, /* auto-confirm id */
+                           tr("Rename"));
 }
 
@@ -622,18 +628,4 @@
         0 /* pcszAutoConfirmId */,
         tr("Discard", "saved state"));
-}
-
-void UIMessageCenter::cannotSetGroups(const CMachine &machine)
-{
-    /* Preserve error-info: */
-    COMResult res(machine);
-    /* Compose machine name: */
-    QString strName = machine.GetName();
-    if (strName.isEmpty())
-        strName = QFileInfo(machine.GetSettingsFilePath()).baseName();
-    /* Show the message: */
-    message(mainWindowShown(), MessageType_Error,
-            tr("Failed to set groups of the virtual machine <b>%1</b>.").arg(strName),
-            formatErrorInfo(res));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45279)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45280)
@@ -215,10 +215,10 @@
     void cannotDeleteMachine(const CMachine &machine, const CProgress &progress);
     void cannotDiscardSavedState(const CConsole &console);
-    void notifyAboutCollisionOnGroupRemovingCantBeResolved(const QString &strName, const QString &strGroupName);
-    int askAboutCollisionOnGroupRemoving(const QString &strName, const QString &strGroupName);
+    void cannotSetGroups(const CMachine &machine);
+    void cannotResolveCollisionAutomatically(const QString &strName, const QString &strGroupName);
+    bool confirmAutomaticCollisionResolve(const QString &strName, const QString &strGroupName);
     int confirmMachineItemRemoval(const QStringList &names);
     int confirmMachineRemoval(const QList<CMachine> &machines);
     bool confirmDiscardSavedState(const QString &strNames);
-    void cannotSetGroups(const CMachine &machine);
     bool remindAboutInaccessibleMedia();
     bool confirmVMReset(const QString &strNames);
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 45279)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 45280)
@@ -353,5 +353,5 @@
     /* Make sure this machine can be opened: */
     CMachine newMachine = vbox.OpenMachine(strTmpFile);
-    if (!vbox.isOk() || newMachine.isNull())
+    if (!vbox.isOk())
     {
         msgCenter().cannotOpenMachine(vbox, strTmpFile);
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 45279)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 45280)
@@ -759,5 +759,5 @@
                 else if (pCollisionSibling->type() == UIGChooserItemType_Group)
                 {
-                    msgCenter().notifyAboutCollisionOnGroupRemovingCantBeResolved(strItemName, pParentItem->name());
+                    msgCenter().cannotResolveCollisionAutomatically(strItemName, pParentItem->name());
                     return;
                 }
@@ -765,5 +765,5 @@
             else if (pItem->type() == UIGChooserItemType_Group)
             {
-                if (msgCenter().askAboutCollisionOnGroupRemoving(strItemName, pParentItem->name()) == QIMessageBox::Ok)
+                if (msgCenter().confirmAutomaticCollisionResolve(strItemName, pParentItem->name()))
                     toBeRenamed << pItem;
                 else
@@ -1999,5 +1999,5 @@
         const QStringList &oldGroupList = m_oldLists.value(strId);
         const UIStringSet &oldGroupSet = UIStringSet::fromList(oldGroupList);
-        /* Make sure group set was changed: */
+        /* Make sure group set changed: */
         if (newGroupSet == oldGroupSet)
             continue;